/**
 * Created by taskaris on 2017-09-28.
 */

var arcgismapservice_StoreColumnsService = new fn_storeColumnsService();
var arcgismapservice_StoreColumnsServiceLayers = new fn_storeColumnsServiceLayers();

init_onload_fn.push(wms_init);

function wms_init() {
    maptab_services_manager_gridpanel_store.add({
        servicetype: 'ArcGIS Map Service',
        serviceform: arcgismapservice_service_form
    });
    Ext.getCmp("maptab_services_manager_gridpanel_columns_service_type").add(arcgismapservice_service_form);
}

var arcgismapservice_service_form = new Ext.Panel({
    xtype: 'panel',
    title: 'Διαχείριση Υπηρεσιών ArcGIS Map Service',
    id: 'arcgismapservice_service_form',
    layout: 'border',
    border: false,
    hidden: true,
    listeners: {
        show: function () {
            Ext.getCmp('arcgismapservice_service_form_layers_grid').getView().refresh();
        }
    },
    items: [
        {
            xtype: 'panel',
            region: 'north',
            layout: 'form',
            border: true,
            height: 80,
            items: [
                {
                    xtype: 'textfield',
                    fieldLabel: _maptab_services_manager_service_address,
                    id: 'maptab_services_manager_arcgismapservice_service_address',
                    width: 300
                }
            ],
            bbar: ['->',
                {
                    xtype: 'checkbox',
                    id: 'maptab_services_manager_arcgismapservice_service_require_authentication',
                    boxLabel: _maptab_services_manager_required_authentication
                },
                {
                    xtype: 'button',
                    iconCls: 'maptab_services_manager_register',
                    text: _maptab_services_manager_register_service,
                    handler: function () {
                        Ext.getCmp('arcgismapservice_service_form_service_grid').setLoading(true);

                        if (Ext.getCmp("maptab_services_manager_arcgismapservice_service_require_authentication").getValue()) {
                            var _w = arcgismapservice_serviceCredentialsWindow(Ext.getCmp('maptab_services_manager_arcgismapservice_service_address').getValue());

                            _w.show();
                        }
                        else {
                            arcgismapservice_register_service(Ext.getCmp('maptab_services_manager_arcgismapservice_service_address').getValue(), "", "");
                        }

                        Ext.getCmp('arcgismapservice_service_form_service_grid').setLoading(false);
                    }
                }
            ]
        },
        {
            xtype: 'gridpanel',
            region: 'center',
            border: true,
            minHeight: 180,
            columnLines: true,
            split: true,
            id: 'arcgismapservice_service_form_service_grid',
            store: arcgismapservice_StoreColumnsService.store,
            columns: arcgismapservice_StoreColumnsService.columns,
            selModel: Ext.create('Ext.selection.CheckboxModel'),
            plugins: [{
                ptype: 'rowexpander',
                pluginId: 'rowexpanderWMSService',
                rowBodyTpl: [
                    '<div style=\"margin-left:50px;width:100%;\"><b>' + _maptab_services_manager_storecolumns_column_service_abstract + ':</b><br> {_serviceAbstract}</div>'
                ]
            }],
            bbar: ['->',
                {
                    xtype: 'button',
                    iconCls: 'maptab_services_manager_unregister',
                    text: _maptab_services_manager_unregister_service,
                    handler: function () {
                        var selected = Ext.getCmp('arcgismapservice_service_form_service_grid').getSelectionModel().getSelection();

                        Ext.each(selected, function (item) {
                            var overlayers = mapGetlayersBy("isBaseLayer", false);

                            for (var i = (overlayers.length - 1); i >= 0; i--) {
                                if (overlayers[i]._serviceObject._serviceUrl == item.get("_serviceUrl")) {
                                    if (typeof overlayers[i]._layerObject !== "undefined") {
                                        // maptab_west_layer_remove_node(maptab_west_layer_get_node_from_id(overlayers[i]._layerObject._layerId));
                                    }
                                }
                            }

                            Ext.getCmp('arcgismapservice_service_form_service_grid').getStore().remove(item);
                        });

                        Ext.getCmp('arcgismapservice_service_form_layers_grid').getStore().removeAll();
                    }
                },
                {
                    xtype: 'button',
                    text: _maptab_services_manager_show_layers,
                    handler: function () {

                        var selected = Ext.getCmp('arcgismapservice_service_form_service_grid').getSelectionModel().getSelection();

                        Ext.getCmp('arcgismapservice_service_form_layers_grid').setLoading(true);

                        Ext.each(selected, function (item) {
                            arcgismapservice_fetch_layers(item.get("_serviceObject"));

                        });

                        Ext.getCmp('arcgismapservice_service_form_layers_grid').setLoading(false);
                    }
                }
            ]
        },
        {
            xtype: 'gridpanel',
            region: 'south',
            border: true,
            height: 200,
            split: true,
            columnLines: true,
            viewConfig: {preserveScrollOnRefresh: true},
            id: 'arcgismapservice_service_form_layers_grid',
            store: arcgismapservice_StoreColumnsServiceLayers.store,
            columns: arcgismapservice_StoreColumnsServiceLayers.columns,
            plugins: [{
                ptype: 'rowexpander',
                pluginId: 'rowexpanderWMSLayer',
                rowBodyTpl: [
                    '<div style=\"margin-left:50px;width:100%;\"><b>' + _maptab_services_manager_storecolumns_column_service_abstract + ':</b><br> {_layerAbstract}</div>'
                ]
            }, {
                ptype: 'bufferedrenderer',
                trailingBufferZone: 20,
                leadingBufferZone: 20
            }],
            selModel: Ext.create('Ext.selection.CheckboxModel'),
            bbar: ['->',
                {
                    xtype: 'button',
                    iconCls: 'maptab_services_manager_unregister',
                    text: _maptab_services_manager_unregister_layer,
                    handler: function () {

                        var selected = Ext.getCmp('arcgismapservice_service_form_layers_grid').getSelectionModel().getSelection();

                        Ext.each(selected, function (item) {

                            var _message = _maptab_services_manager_unregister_layer_message;

                            _message = _message.replace("{_layerTitle}", item.get("_layerTitle"));

                            _message = _message.replace("{_layerName}", item.get("_layerName"));

                            var mask = fn_loadingMask(maptab_services_manager, _message);

                            mask.show();

                            maptab_west_layer_remove_node(maptab_west_layer_get_node_from_id(item.get("_layerObject")._layerId));

                            Ext.getCmp('arcgismapservice_service_form_layers_grid').getView().refresh();

                            if (mapFindLayerById(item.get("_layerId")))
                            {
                                var _layer2remove = mapFindLayerById(item.get("_layerId"));
                                map.removeLayer(_layer2remove);
                            }

                            mask.hide();

                        });

                    }
                },
                {
                    xtype: 'button',
                    iconCls: 'map_general_setting_btn',
                    text: _maptab_services_manager_settings_layer,
                    hidden: true,
                    handler: function () {
                        // wms_layer_settings_window.show();
                    }
                },
                {
                    xtype: 'button',
                    iconCls: 'maptab_services_manager_register',
                    text: _maptab_services_manager_register_layer,
                    handler: function () {

                        var selected = Ext.getCmp('arcgismapservice_service_form_layers_grid').getSelectionModel().getSelection();

                        Ext.each(selected, function (item) {

                            // var arcgis_layer = new OpenLayers.Layer.ArcGIS93Rest(
                            //     item.data._serviceObject._serviceId + '//' + item.data._layerId,
                            //     item.data._serviceObject._serviceUrl + "/export",
                            //     {
                            //         layers: "show:" + item.data._layerId,
                            //         transparent: true, format: 'image/png'
                            //     },
                            //     {
                            //         projection: new OpenLayers.Projection("EPSG:3857"),
                            //         isBaseLayer: false
                            //     }
                            // );
                            //
                            // map.addLayer(arcgis_layer);


                            var _message = _maptab_services_manager_loading_layer_message;

                            _message = _message.replace("{_layerTitle}", item.get("_layerTitle"));

                            _message = _message.replace("{_layerName}", item.get("_layerName"));

                            var mask = fn_loadingMask(maptab_services_manager, _message);

                            mask.show();

                            arcgismapservice_register_layer(item.get("_layerObject"));

                            Ext.getCmp('arcgismapservice_service_form_layers_grid').getView().refresh();

                            mask.hide();
                        });
                    }
                }
            ]
        }
    ]
});


function arcgismapservice_serviceCredentialsWindow(_serviceUrl) {
    var _w = new Ext.Window({
        width: 250,
        height: 120,
        modal: true,
        shim: true,
        title: _maptab_services_manager_service_credentials,
        resizable: true,
        closeAction: 'destroy',
        layout: 'fit',
        items: [{
            xtype: 'panel',
            layout: 'form',
            bbar: ['->',
                {
                    xtype: 'button',
                    text: _maptab_services_manager_service_cancel,
                    iconCls: 'map_general_cancel_btn',
                    tabIndex: 3,
                    handler: function (btn, e) {
                        btn.findParentByType("window").hide();
                    }
                },
                {
                    xtype: 'button',
                    text: _maptab_services_manager_register_service,
                    iconCls: 'maptab_services_issecure',
                    tabIndex: 4,
                    handler: function (btn, e) {
                        var _panel = btn.findParentByType("panel").items.items;

                        var _username = fn_encrypt(_panel[0].getValue());

                        var _password = fn_encrypt(_panel[1].getValue());

                        if ((_username != "") && (_password != "")) {
                            arcgismapservice_register_service(_serviceUrl, _username, _password);
                        }

                        _username = null;
                        _password = null;

                        btn.findParentByType("window").hide();
                    }
                }
            ],
            items: [
                {
                    xtype: 'textfield',
                    fieldLabel: _maptab_services_manager_service_username,
                    tabIndex: 1
                },
                {
                    xtype: 'textfield',
                    fieldLabel: _maptab_services_manager_service_password,
                    inputType: 'password',
                    tabIndex: 2
                }
            ]
        }]
    });

    return _w;
}

function arcgismapservice_register_service(_serviceUrl, _username, _password) {
    var r = new fn_get();

    r._async = false;

    r._data.push({
        _serviceType: "ARCGISMAPSERVICE",
        _serviceUrl: _serviceUrl,
        _request: "registerService",
        _username: _username,
        _password: _password,
        _projections: map_basemapProjections
    });

    var response;

    try {
        response = Ext.JSON.decode(r.get().responseText);
    }
    catch (err) {
        return;
    }


    switch (response[0]._responseCode) {
        case "401":

            var _w = arcgismapservice_serviceCredentialsWindow(_serviceUrl);

            _w.show();

            break;

        case "200":

            var records = response[0]._response;

            if ((records._version != "") || (records._version != null)) {
                arcgismapservice_StoreColumnsService.store.add({
                    _isSecure: false,
                    _serviceTitle: records._mapName,
                    _serviceUrl: records._serviceUrl,
                    _serviceAbstract: records._serviceDescription,
                    _version: records._currentVersion,
                    _serviceObject: records
                });
            }
            return records;

            break;
    }
}

function arcgismapservice_fetch_layers(_serviceObject) {
    if (typeof _serviceObject !== "undefined") {
        arcgismapservice_StoreColumnsServiceLayers.store.removeAll();

        var r = new fn_get();

        r._async = false;

        r._data.push({
            _serviceType: "ARCGISMAPSERVICE",
            _serviceUrl: _serviceObject._serviceUrl,
            _request: "fetchLayers",
            _username: _serviceObject._username,
            _password: _serviceObject._password
        });

        var response = Ext.JSON.decode(r.get().responseText);

        var records = response[0]._response;

        Ext.each(records, function (item) {
            item._layerTitle = config_getProperty(item, _serviceObject, "_layerTitle", item._name);

            item._layerAbstract = config_getProperty(item, _serviceObject, "_layerAbstract", item._layerAbstract);

            var legend_url = item._layerLegend;

            if (_serviceObject._isSecure == true) {
                legend_url = fn_surl(item._layerLegend, _serviceObject._username, _serviceObject._password, "proxy&method=get");
            }

            arcgismapservice_StoreColumnsServiceLayers.store.add({
                _layerId: item._layerId,
                _layerName: item._name,
                _layerTitle: item._name,
                _layerAbstract: item._name,
                _layerObject: item
            });
        });
    }
}

function arcgismapservice_register_layer(_servicelayerObject) {
    if (!mapFindLayerById(_servicelayerObject._layerId)) {
        var r = new fn_get();

        r._async = false;

        r._data.push({
            _serviceType: "ARCGISMAPSERVICE",
            _serviceUrl: _servicelayerObject._serviceUrl,
            _request: "registerLayer",
            _username: _servicelayerObject._username,
            _password: _servicelayerObject._password,
            _layerName: _servicelayerObject._layerName,
            _layerId: _servicelayerObject._id
        });

        var response = Ext.JSON.decode(r.get().responseText);

        var records = response[0]._response;

        var _node = maptab_west_layer_tree_panel_tree_json_store.getNodeById('maptab_west_layer_tree_panel_tabs_layers_layers_node');

        if (_node == null) {
            _node = maptab_west_layer_tree_panel_tree_json_store.getNodeById('maptab_west_layer_tree_panel_tabs_layers_layers_node');
        }

        if (!mapFindLayerById(records._layerId)) {
            var _layerNode = maptab_west_layer_add_arcgismaplayer(records, _node);

            var arcgis_layer = new OpenLayers.Layer.ArcGIS93Rest(
                records._layerId,
                records._serviceUrl + "/export",
                {
                    layers: "show:" + records._id,
                    transparent: true,
                    format: 'png'
                },
                {
                    projection: new OpenLayers.Projection("EPSG:3857"),
                    isBaseLayer: false
                }
            );
            arcgis_layer.id = records._layerId;

            map.addLayer(arcgis_layer);

            // if (installing)
            // {
            //     config_update_addLayer(_layerObject,_serviceObject);
            // }
            //
            // config_init_layerScales(_layerObject);

            // maptab_west_layer_reorder_layer();

        }

        //
        // var record;
        //
        // record = config_findConfig(_layerObject,_serviceObject);
        //
        // if (!record)
        // {
        //     var response=Ext.JSON.decode(r.get().responseText);
        //
        //     record = response[0]._response;
        //
        //     _layerObject._attributesFields=record._attributes;
        //
        // }else{
        //
        //     _layerObject._attributesFields=record._attributesFields;
        //
        //     _layerObject._visibility = record._visibility;
        //
        //     _layerObject._opacity = record._opacity;
        //
        //     _layerObject._singleTile = record._singleTile;
        // }
        //
        // _layerObject._nativeSRS=record._nativeSRS;
        //
        // _layerObject._supportedEPSG=_serviceObject._supportedEPSG;
        //
        // var legend_url=_layerObject._layerLegend;
        //
        // if (_serviceObject._isSecure==true)
        // {
        //     legend_url=fn_surl(_layerObject._layerLegend,_serviceObject._username,_serviceObject._password,"proxy&method=get");
        // }
        //
        // _layerObject._layerLegend=legend_url;
        //
        // _layerObject._xy=fn_determineAxisOrder(record._nativeSRS);
        //
        // _layerObject._geometryField=record._geometryField;
        //
        // mapBeforeAddLayer(_serviceObject,_layerObject);
        //
        // if ((_layerObject._nativeSRS) && (_layerObject._geometryField))
        // {
        //
        //     _layerObject._isSearchable=true;
        //
        //     _layerObject._loadedStatus=1;
        //
        // }else
        // {
        //     _layerObject._loadedStatus=2;
        // }
        //
        // _layerObject._layer=wms_map_layer(_serviceObject,_layerObject);
        //
        // mapAddLayer(_serviceObject,_layerObject);


    }
}

function maptab_west_layer_add_arcgismaplayer(_layer, _node) {
    var r = new fn_get();

    r._async = false;

    r._data.push({
        _serviceType: "ARCGISMAPSERVICE",
        _serviceUrl: _layer._serviceUrl,
        _request: "getLegend",
        _username: _layer._username,
        _password: _layer._password,
        _layerName: _layer._layerName,
        _layerId: _layer._id
    });

    var response = Ext.JSON.decode(r.get().responseText);

    var legend = response[0]._response[0];

    _node.insertBefore({
        id: _layer._layerId,
        text: legend.label,
        leaf: true,
        qtip: '<img src=\"' + 'data:image/png;base64,' + legend.imageData + '\">',
        icon: 'data:image/png;base64,' + legend.imageData,
        iconCls: 'maptab_services_manager_layer_legend_size',
        checked: true,
        tools: "<img src=\"" + host + "images/layer_info.png\" width=\"12px\" data-qtip=\"<div style='width:260px;'><b>" + legend.label + "</b><br>" + legend.label + "</b><br>" + legend.label + "</div>\">  <img src=\"" + host + "images/reorder.png\" width=\"12px\" style='cursor:move;'>"
    }, _node.firstChild);

    return _node;
}


