Ext.define('serviceDXFLayersStoreModel', {
  extend: 'Ext.data.Model',
  fields: [
    { name: '_layerId', type: 'string' },
    { name: '_zoomto' },
    { name: '_layerName', type: 'string' },
    { name: '_layerFile', type: 'string' },
    { name: '_layerExtent', type: 'object' },
    { name: '_layerObject', type: 'object' },
    { name: '_serviceObject', type: 'object' }
  ]
});

function fn_storeColumnsDXFServiceLayers() {
  var obj = {
    store: Ext.create('Ext.data.Store', {
      model: 'serviceDXFLayersStoreModel',
      data: []
    }),
    columns: [
      {
        dataIndex: '_layerId',
        hidden: true,
        hideable: false
      },
      {
        header: '',
        dataIndex: 'mydrawzoomto',
        width: 40,
        renderer: dxf_zoomto_renderer
      },
      {
        header: _maptab_services_manager_storecolumns_column_layer_name,
        dataIndex: '_layerName',
        sortable: true,
        width: 200
      },
      {
        header: _maptab_services_manager_storecolumns_column_layer_file,
        dataIndex: '_layerFile',
        sortable: true,
        width: 200
      },
      {
        dataIndex: '_layerExtent',
        hidden: true,
        hideable: false
      },
      {
        dataIndex: '_layerObject',
        hidden: true,
        hideable: false
      },
      {
        dataIndex: '_serviceObject',
        hidden: true,
        hideable: false
      }
    ]
  };

  return obj;
}

function dxf_zoomto_renderer(value, metaData, record, row, col, store, gridView) {
  return "<img src='" + host + "images/zoomExtent.png' width='20px' height='20px' onClick=\"fn_dxf_zoomto('" + record.get("_layerExtent") + "');\">";
}

function fn_dxf_zoomto(extent) {
  var e = extent.split(',');
  var bounds = new OpenLayers.Bounds(parseFloat(e[0]), parseFloat(e[1]), parseFloat(e[2]), parseFloat(e[3]));
  map.zoomToExtent(bounds);
}

var dxf_StoreColumnsServiceLayers = new fn_storeColumnsDXFServiceLayers();

init_onload_fn.push(dxf_init);

function dxf_init() {
  maptab_services_manager_gridpanel_store.add({ servicetype: 'DXF', serviceform: dxf_service_form });
  Ext.getCmp("maptab_services_manager_gridpanel_columns_service_type").add(dxf_service_form);
}

var dxf_service_form_layers_grid = {
  xtype: 'gridpanel',
  region: 'south',
  border: true,
  height: 375,
  split: true,
  columnLines: true,
  viewConfig: { preserveScrollOnRefresh: true },
  id: 'dxf_service_form_layers_grid',
  store: dxf_StoreColumnsServiceLayers.store,
  columns: dxf_StoreColumnsServiceLayers.columns,
  selModel: Ext.create('Ext.selection.CheckboxModel'),
  bbar: ['->',
    {
      xtype: 'button',
      iconCls: 'maptab_services_manager_unregister',
      text: _maptab_services_manager_unregister_layer,
      handler: function () {
        var selected = Ext.getCmp('dxf_service_form_layers_grid').getSelectionModel().getSelection();

        Ext.each(selected, function (item) {
          var _message = _maptab_services_manager_unregister_layer_message;
          _message = _message.replace("{_layerFile}", item.get("_layerFile"));
          _message = _message.replace("{_layerName}", item.get("_layerName"));
          var mask = fn_loadingMask(maptab_services_manager, _message);
          mask.show();
          map.layers.forEach(function (ly) {
            if (ly.name === item.get("_layerId")) {
              map.removeLayer(ly);
              dxf_StoreColumnsServiceLayers.store.remove(dxf_StoreColumnsServiceLayers.store.findRecord('_layerId', ly.name, 0, false, true, true));
            }
          });
          Ext.getCmp('dxf_service_form_layers_grid').getView().refresh();
          mask.hide();
        });
      }
    }
  ]
}

var dxf_service_form = new Ext.Panel({
  xtype: 'panel',
  title: 'DXF',
  id: 'dxf_service_form',
  layout: 'border',
  border: false,
  hidden: true,
  items: [
    {
      xtype: 'form',
      region: 'north',
      anchor: '100%',
      fileUpload: true,
      isUpload: true,
      id: 'maptab_services_manager_dxf_form',
      method: 'POST',
      enctype: 'multipart/form-data',
      border: true,
      height: 120,
      items: [
        {
          xtype: 'textfield',
          fieldLabel: _maptab_services_manager_service_name,
          id: 'maptab_services_manager_dxf_name',
          anchor: '100%'
        },
        {
          xtype: 'filefield',
          fieldLabel: 'Αρχείο DXF',
          name: 'dxf',
          id: 'maptab_services_manager_dxf_file',
          anchor: '100%'
        },
        {
          xtype: 'combo',
          loadMask: true,
          autoScroll: true,
          autoShow: true,
          anchor: '100%',
          id: 'maptab_services_manager_dxf_projection',
          fieldLabel: 'Σύστημα Συντεταγμένων',
          store: new Ext.data.SimpleStore({
            fields: ['value', 'name'],
            data: [
              ["EPSG:2100", "EPSG:2100"],
              ["EPSG:4326", "EPSG:4326"],
              ["EPSG:3785", "EPSG:3785"],
              ["EPSG:3857", "EPSG:3857"],
              ["EPSG:32717", "EPSG:32717"]
            ]
          }),
          displayField: 'name',
          valueField: 'value',
          emptyText: "",
          forceSelection: true,
          triggerAction: 'all',
          selectOnFocus: false,
          mode: 'local',
          editable: false
        }
      ],
      bbar: ['->',
        {
          xtype: 'button',
          iconCls: 'maptab_services_manager_register',
          text: _maptab_services_manager_register_layer,
          handler: function () {

            Ext.getCmp('maptab_services_manager_dxf_form').setLoading(true);

            var file = this.up().up().down('filefield').el.down('input[type=file]').dom.files[0];
            var reader = new FileReader();
            reader.readAsText(file);
            reader.onload = function (e) {
              var fileText = e.target.result;
              var parser = new DxfParser();
              var dxf = null;
              try {
                dxf = parser.parseSync(fileText);
              } catch (err) {
                alert("error...");
                Ext.getCmp('maptab_services_manager_dxf_form').setLoading(false);
              }

              var style = new OpenLayers.Style({
                fillColor: '#000000',
                fillOpacity: 0,
                strokeColor: '#000000',
                strokeWidth: 1,
                label: '${getLabel}',
                labelAlign: 'lb',
                fontColor: "black",
                fontFamily: "Arial",
                fontSize: '${getFontSize}',
              }, {
                context: {
                  getLabel: function (feature) {
                    if (feature.attributes.text === '-') {
                      return '';
                    } else {
                      return feature.attributes.text;
                    }
                  },
                  getFontSize: function (feature) {
                    if (map.zoom > 19) {
                      return 8;
                    } else if (map.zoom === 19) {
                      return 6;
                    } else if (map.zoom === 18) {
                      return 4;
                    } else {
                      return 1;
                    }
                  },
                }
              });

              var features = [];
              dxf.entities.forEach(function (e) {
                if (/*e.type === "POINT" ||*/ e.type === "TEXT") {
                  var x = null;
                  var y = null;
                  var text = '-';
                  if (e.type === "TEXT") {
                    x = e.startPoint.x;
                    y = e.startPoint.y;
                    text = e.text;
                  } else {
                    x = e.position.x;
                    y = e.position.y;
                  }
                  var geom = new OpenLayers.Geometry.Point(x, y);
                  if (Ext.getCmp('maptab_services_manager_dxf_projection').getValue() !== mapGetCurrentProjection()) {
                    geom.transform(new OpenLayers.Projection(Ext.getCmp('maptab_services_manager_dxf_projection').getValue()), new OpenLayers.Projection(mapGetCurrentProjection()));
                  }
                  var attributes = { layer: e.layer, text: text };
                  var feature = new OpenLayers.Feature.Vector(geom, attributes);
                  features.push(feature);
                } else if (e.type === "LWPOLYLINE" && e.shape) {
                  var vertices = [];
                  for (let i = 0; i < e.vertices.length; i++) {
                    var geom = new OpenLayers.Geometry.Point(e.vertices[i].x, e.vertices[i].y);
                    if (Ext.getCmp('maptab_services_manager_dxf_projection').getValue() !== mapGetCurrentProjection()) {
                      geom.transform(new OpenLayers.Projection(Ext.getCmp('maptab_services_manager_dxf_projection').getValue()), new OpenLayers.Projection(mapGetCurrentProjection()));
                    }
                    vertices.push(geom);
                  }

                  var geom = new OpenLayers.Geometry.Point(e.vertices[0].x, e.vertices[0].y);
                  if (Ext.getCmp('maptab_services_manager_dxf_projection').getValue() !== mapGetCurrentProjection()) {
                    geom.transform(new OpenLayers.Projection(Ext.getCmp('maptab_services_manager_dxf_projection').getValue()), new OpenLayers.Projection(mapGetCurrentProjection()));
                  }
                  vertices.push(geom);

                  var attributes = { layer: e.layer, text: '-' };
                  var feature = new OpenLayers.Feature.Vector(new OpenLayers.Geometry.LineString(vertices), attributes);
                  features.push(feature);
                } else if (e.type === "POLYLINE" && e.shape) {
                  var vertices = [];
                  for (let i = 0; i < e.vertices.length; i++) {
                    var geom = new OpenLayers.Geometry.Point(e.vertices[i].x, e.vertices[i].y);
                    if (Ext.getCmp('maptab_services_manager_dxf_projection').getValue() !== mapGetCurrentProjection()) {
                      geom.transform(new OpenLayers.Projection(Ext.getCmp('maptab_services_manager_dxf_projection').getValue()), new OpenLayers.Projection(mapGetCurrentProjection()));
                    }
                    vertices.push(geom);
                  }

                  var geom = new OpenLayers.Geometry.Point(e.vertices[0].x, e.vertices[0].y);
                  if (Ext.getCmp('maptab_services_manager_dxf_projection').getValue() !== mapGetCurrentProjection()) {
                    geom.transform(new OpenLayers.Projection(Ext.getCmp('maptab_services_manager_dxf_projection').getValue()), new OpenLayers.Projection(mapGetCurrentProjection()));
                  }
                  vertices.push(geom);

                  var attributes = { layer: e.layer, text: '-' };
                  var feature = new OpenLayers.Feature.Vector(new OpenLayers.Geometry.LineString(vertices), attributes);
                  features.push(feature);
                } else if (e.type === "LWPOLYLINE" || e.type === "POLYLINE" || e.type === "LINE") {
                  var vertices = [];
                  e.vertices.forEach(function (v) {
                    var geom = new OpenLayers.Geometry.Point(v.x, v.y);
                    if (Ext.getCmp('maptab_services_manager_dxf_projection').getValue() !== mapGetCurrentProjection()) {
                      geom.transform(new OpenLayers.Projection(Ext.getCmp('maptab_services_manager_dxf_projection').getValue()), new OpenLayers.Projection(mapGetCurrentProjection()));
                    }
                    vertices.push(geom);
                  })
                  var attributes = { layer: e.layer, text: '-' };
                  var feature = new OpenLayers.Feature.Vector(new OpenLayers.Geometry.LineString(vertices), attributes);
                  features.push(feature);
                } else if (e.type === "CIRCLE") {
                  var pCenter = new OpenLayers.Geometry.Point(e.center.x, e.center.y);
                  var geom = new OpenLayers.Geometry.Polygon.createRegularPolygon(pCenter, e.radius, 70, 0);
                  if (Ext.getCmp('maptab_services_manager_dxf_projection').getValue() !== mapGetCurrentProjection()) {
                    geom.transform(new OpenLayers.Projection(Ext.getCmp('maptab_services_manager_dxf_projection').getValue()), new OpenLayers.Projection(mapGetCurrentProjection()));
                  }
                  var attributes = { layer: e.layer, text: '-' };
                  var feature = new OpenLayers.Feature.Vector(geom, attributes);
                  features.push(feature);
                }
              })

              var layer = new OpenLayers.Layer.Vector("DXF-" + Ext.getCmp('maptab_services_manager_dxf_name').getValue(), { styleMap: style });
              layer.addFeatures(features);

              map.addLayer(layer);

              map.zoomToExtent(layer.getDataExtent());

              dxf_StoreColumnsServiceLayers.store.add({
                _layerId: "DXF-" + Ext.getCmp('maptab_services_manager_dxf_name').getValue(),
                _layerExtent: layer.getDataExtent(),
                _layerObject: layer,
                _layerName: Ext.getCmp('maptab_services_manager_dxf_name').getValue(),
                _layerFile: Ext.getCmp('maptab_services_manager_dxf_file').getValue().split('\\')[2],
                _layerAbstract: Ext.getCmp('maptab_services_manager_dxf_file').getValue()
              });

              Ext.getCmp('maptab_services_manager_dxf_form').setLoading(false);
            };

          }
        }
      ]
    },
    dxf_service_form_layers_grid
  ]
});

function dxf_register_layer(_serviceObject, _layerObject) {

  if (!mapFindLayerById(_layerObject._layerId)) {
    mapBeforeAddLayer(_serviceObject, _layerObject);

    _layerObject._loadedStatus = 1;

    var _attributesFields = _layerObject._attributesFields;

    _attributesFields.forEach(function (entry) {
      entry._attributeName = entry._attributeName.name;
    });

    _layerObject._layer = dxf_map_layer(_serviceObject, _layerObject);

    mapAddLayer(_serviceObject, _layerObject);

  }
}