/**
 * Created by taskaris on 2017-08-04.
 */

var advancedprint_translation = {
    el_gr: {
        print_window_title: 'Επιλογές Εκτύπωσης',
        output_title: 'Τίτλος Χάρτη:',
        output_comment: 'Σχόλιο Χαρτη:',
        output_template: 'Επιλογή Template:',
        output_scale: 'Επιλογή Κλίμακας:',
        output_format: 'Επιλογή Format:',
        output_dpi: 'Επιλογή Ανάλυσης:',
        selected_basemap: 'Επιλογή Υποβάθρου:',
        selected_basemap_none: 'Κανένα',
        alert1: 'Παρακαλώ επιλέξτε Template',
        alert2: 'Παρακαλώ επιλέξτε Κλίμακα',
        alert3: 'Παρακαλώ επιλέξτε Ανάλυση'
    },
    en_us: {
        print_window_title: 'Print Configuration',
        output_title: 'Map Title:',
        output_comment: 'Map Comment:',
        output_template: 'Select Template:',
        output_scale: 'Select Scale:',
        output_format: 'Select Format:',
        output_dpi: 'Select dpi:',
        selected_basemap: 'Select Basemap:',
        selected_basemap_none: 'None',
        alert1: 'Please select Template',
        alert2: 'Please select Scale',
        alert3: 'Please select dpi'
    }
};

var advancedprint_googlekey = "AIzaSyA3s0Cl9pp2deUfDl_Sf-vzhkzh7pyQtVg";
var advancedprint_infourl = 'http://localhost:8080/geoserver/pdf/info.json';
var advancedprint_printCapabilities;

var advancedprint_scales = [];
var advancedprint_dpis = [];
var advancedprint_outputFormats = [];
var advancedprint_layouts = [];
var advancedprint_printURL = null;
var advancedprint_createURL = null;

var advancedprint_printExtent, advancedprint_printExtentLayer, advancedprint_dragPrintExtentCtrl;

var advancedprint_units = 'meters';
var advancedprint_srs = 'EPSG:900913';
var advancedprint_resourcesUrl = 'http://localhost:8080/img';

function advancedprint_show_window() {

    try {
        Ext.getCmp('advancedprint_window').destroy();
    } catch (err) {
    }

    // Create the Print Extent Feature layer that is used to display the printable extent of a layout
    var printExtentStyle = new OpenLayers.Style({
        fillColor: '#FF0000',
        fillOpacity: .2,
        strokeColor: '#FF0000',
        strokeWidth: 2,
    });
    var styleMap = new OpenLayers.StyleMap({
        'default': printExtentStyle
    });
    advancedprint_printExtentLayer = new OpenLayers.Layer.Vector("Print Extents Layer", {
        styleMap: styleMap
    });

    // Create a feature to represent the print extent and initially set its geometry to nothing relevant
    advancedprint_printExtent = new OpenLayers.Feature.Vector(OpenLayers.Geometry.fromWKT("POLYGON((-1 -1,1 -1,1 1,-1 1,-1 -1))"));

    // Add the feature to the map
    advancedprint_printExtentLayer.addFeatures([advancedprint_printExtent]);
    map.addLayer(advancedprint_printExtentLayer);

    // Add a DragFeature control so the printExtentFeature can be manipulated by users
    advancedprint_dragPrintExtentCtrl = new OpenLayers.Control.DragFeature(advancedprint_printExtentLayer);
    map.addControl(advancedprint_dragPrintExtentCtrl);

    var _w = new Ext.Window({
        width: 300,
        height: 280,
        id: 'advancedprint_window',
        title: advancedprint_translation[language].print_window_title,
        closeAction: 'destroy',
        modal: false,
        layout: 'border',
        resizable: false,
        minimizable: false,
        constrain: true,
        items: {
            xtype: 'panel',
            border: false,
            items: [
                {
                    xtype: 'combo',
                    width: 280,
                    loadMask: true,
                    autoScroll: true,
                    autoShow: true,
                    id: 'advancedprint_template',
                    fieldLabel: advancedprint_translation[language].output_template,
                    store: new Ext.data.SimpleStore({
                        fields: ['title', 'value'],
                        data: advancedprint_layouts
                    }),
                    displayField: 'title',
                    valueField: 'value',
                    emptyText: advancedprint_translation[language].output_template,
                    value: advancedprint_translation[language].output_template,
                    forceSelection: true,
                    triggerAction: 'all',
                    selectOnFocus: false,
                    mode: 'local',
                    editable: false,
                    listeners: {
                        select: function (combo, records) {

                            var t = Ext.getCmp('advancedprint_template').getValue();

                            if (t.includes('map only')) {
                                Ext.getCmp('advancedprint_title').disable();
                                Ext.getCmp('advancedprint_comment').disable();
                            } else {
                                Ext.getCmp('advancedprint_title').enable();
                                Ext.getCmp('advancedprint_comment').enable();
                            }

                            Ext.getCmp('advancedprint_basemap').enable();
                            Ext.getCmp('advancedprint_scale').enable();
                            Ext.getCmp('advancedprint_format').enable();
                            Ext.getCmp('advancedprint_dpi').enable();

                            advancedprint_createPrintExtent();

                        }
                    }
                },
                {
                    xtype: 'textfield',
                    id: 'advancedprint_title',
                    fieldLabel: advancedprint_translation[language].output_title,
                    disabled: true,
                    width: 280
                },
                {
                    xtype: 'textfield',
                    id: 'advancedprint_comment',
                    fieldLabel: advancedprint_translation[language].output_comment,
                    disabled: true,
                    width: 280
                },
                {
                    xtype: 'combo',
                    width: 280,
                    loadMask: true,
                    autoScroll: true,
                    autoShow: true,
                    id: 'advancedprint_basemap',
                    fieldLabel: advancedprint_translation[language].selected_basemap,
                    store: new Ext.data.SimpleStore({
                        fields: ['name', 'value'],
                        data: [[advancedprint_translation[language].selected_basemap_none, 'none'], ['Openstreetmap', 'openstreetmap'], ['Google Satellite', 'satellite'], ['Google Street', 'roadmap'], ['Google Hybrid', 'hybrid'], ['Google Terrain', 'terrain']]
                    }),
                    displayField: 'name',
                    valueField: 'value',
                    emptyText: advancedprint_translation[language].selected_basemap_none,
                    value: advancedprint_translation[language].selected_basemap_none,
                    forceSelection: true,
                    triggerAction: 'all',
                    selectOnFocus: false,
                    mode: 'local',
                    editable: false,
                    disabled: true
                },
                {
                    xtype: 'combo',
                    width: 280,
                    loadMask: true,
                    autoScroll: true,
                    autoShow: true,
                    id: 'advancedprint_scale',
                    fieldLabel: advancedprint_translation[language].output_scale,
                    store: new Ext.data.SimpleStore({
                        fields: ['name', 'value'],
                        data: advancedprint_scales
                    }),
                    displayField: 'name',
                    valueField: 'value',
                    emptyText: advancedprint_translation[language].output_scale,
                    value: advancedprint_translation[language].output_scale,
                    forceSelection: true,
                    triggerAction: 'all',
                    selectOnFocus: false,
                    mode: 'local',
                    editable: false,
                    disabled: true,
                    listeners: {
                        select: function (combo, records) {
                            // Calculate new bounds for the print extent for the new scale setting
                            var bounds = advancedprint_calculatePrintBounds(combo.getValue());

                            // Convert the bounds to a geometry
                            var geometry = bounds.toGeometry();

                            // Update the print extent's geometry
                            advancedprint_updatePrintExtentGeometry(geometry);
                        }
                    }
                },
                {
                    xtype: 'combo',
                    width: 280,
                    loadMask: true,
                    autoScroll: true,
                    autoShow: true,
                    id: 'advancedprint_format',
                    fieldLabel: advancedprint_translation[language].output_format,
                    store: new Ext.data.SimpleStore({
                        fields: ['title', 'value'],
                        data: advancedprint_outputFormats
                    }),
                    displayField: 'title',
                    valueField: 'value',
                    emptyText: advancedprint_translation[language].output_format,
                    value: advancedprint_translation[language].output_format,
                    forceSelection: true,
                    triggerAction: 'all',
                    selectOnFocus: false,
                    mode: 'local',
                    editable: false,
                    disabled: true
                },
                {
                    xtype: 'combo',
                    width: 280,
                    loadMask: true,
                    autoScroll: true,
                    autoShow: true,
                    id: 'advancedprint_dpi',
                    fieldLabel: advancedprint_translation[language].output_dpi,
                    store: new Ext.data.SimpleStore({
                        fields: ['name', 'value'],
                        data: advancedprint_dpis
                    }),
                    displayField: 'name',
                    valueField: 'value',
                    emptyText: advancedprint_translation[language].output_dpi,
                    value: advancedprint_translation[language].output_dpi,
                    forceSelection: true,
                    triggerAction: 'all',
                    selectOnFocus: false,
                    mode: 'local',
                    editable: false,
                    disabled: true
                }
            ]
        },
        bbar: ['->', {
            xtype: 'button',
            iconCls: 'maptab_toolbar_general_print',
            tooltip: _maptab_toolbar_general_print,
            text: _maptab_toolbar_general_print,
            handler: function () {
                advancedprint_print();
            }
        }],
        listeners: {
            close: function () {
                map.removeLayer(advancedprint_printExtentLayer);
            }
        }
    });

    return _w;
}

function advancedprint_print() {

    if (Ext.getCmp('advancedprint_template').getValue() === null) {
        alert(advancedprint_translation[language].alert1);
        return;
    }
    if (Ext.getCmp('advancedprint_scale').getValue() === null) {
        alert(advancedprint_translation[language].alert2);
        return;
    }
    if (Ext.getCmp('advancedprint_dpi').getValue() === null) {
        alert(advancedprint_translation[language].alert3);
        return;
    }

    var dly = [];

    var lly = [];

    var overlayers = mapGetlayersBy("isBaseLayer", false);

    switch (Ext.getCmp('advancedprint_basemap').getValue()) {
        case 'openstreetmap':
            dly.push(
                {
                    baseURL: 'http://a.tile.openstreetmap.org',
                    singleTile: false,
                    type: 'OSM',
                    maxExtent: [-20037508.3392, -20037508.3392, 20037508.3392, 20037508.3392],
                    tileSize: [256, 256],
                    extension: 'png',
                    resolutions: [156543.0339, 78271.51695, 39135.758475, 19567.8792375, 9783.93961875, 4891.969809375, 2445.9849046875, 1222.99245234375, 611.496226171875, 305.7481130859375, 152.87405654296876, 76.43702827148438, 38.21851413574219, 19.109257067871095, 9.554628533935547, 4.777314266967774, 2.388657133483887, 1.1943285667419434, 0.5971642833709717]
                }
            );
            break;
        case 'satellite':
            dly.push(
                {
                    baseURL: 'http://maps.google.com/maps/api/staticmap?key=' + advancedprint_googlekey,
                    type: 'TiledGoogle',
                    sensor: false,
                    maptype: 'satellite',
                    maxExtent: [-20037508.3392, -20037508.3392, 20037508.3392, 20037508.3392],
                    extension: 'png',
                    format: 'image/png',
                    resolutions: [156543.0339, 78271.51695, 39135.758475, 19567.8792375, 9783.93961875, 4891.969809375, 2445.9849046875, 1222.99245234375, 611.496226171875, 305.7481130859375, 152.87405654296876, 76.43702827148438, 38.21851413574219, 19.109257067871095, 9.554628533935547, 4.777314266967774, 2.388657133483887, 1.1943285667419434, 0.5971642833709717]
                }
            );
            break;
        case 'roadmap':
            dly.push(
                {
                    baseURL: 'http://maps.google.com/maps/api/staticmap?key=' + advancedprint_googlekey,
                    type: 'TiledGoogle',
                    sensor: false,
                    maptype: 'roadmap',
                    maxExtent: [-20037508.3392, -20037508.3392, 20037508.3392, 20037508.3392],
                    extension: 'png',
                    format: 'image/png',
                    resolutions: [156543.0339, 78271.51695, 39135.758475, 19567.8792375, 9783.93961875, 4891.969809375, 2445.9849046875, 1222.99245234375, 611.496226171875, 305.7481130859375, 152.87405654296876, 76.43702827148438, 38.21851413574219, 19.109257067871095, 9.554628533935547, 4.777314266967774, 2.388657133483887, 1.1943285667419434, 0.5971642833709717]
                }
            );
            break;
        case 'hybrid':
            dly.push(
                {
                    baseURL: 'http://maps.google.com/maps/api/staticmap?key=' + advancedprint_googlekey,
                    type: 'TiledGoogle',
                    sensor: false,
                    maptype: 'hybrid',
                    maxExtent: [-20037508.3392, -20037508.3392, 20037508.3392, 20037508.3392],
                    extension: 'png',
                    format: 'image/png',
                    resolutions: [156543.0339, 78271.51695, 39135.758475, 19567.8792375, 9783.93961875, 4891.969809375, 2445.9849046875, 1222.99245234375, 611.496226171875, 305.7481130859375, 152.87405654296876, 76.43702827148438, 38.21851413574219, 19.109257067871095, 9.554628533935547, 4.777314266967774, 2.388657133483887, 1.1943285667419434, 0.5971642833709717]
                }
            );
            break;
        case 'terrain':
            dly.push(
                {
                    baseURL: 'http://maps.google.com/maps/api/staticmap?key=' + advancedprint_googlekey,
                    type: 'TiledGoogle',
                    sensor: false,
                    maptype: 'terrain',
                    maxExtent: [-20037508.3392, -20037508.3392, 20037508.3392, 20037508.3392],
                    extension: 'png',
                    format: 'image/png',
                    resolutions: [156543.0339, 78271.51695, 39135.758475, 19567.8792375, 9783.93961875, 4891.969809375, 2445.9849046875, 1222.99245234375, 611.496226171875, 305.7481130859375, 152.87405654296876, 76.43702827148438, 38.21851413574219, 19.109257067871095, 9.554628533935547, 4.777314266967774, 2.388657133483887, 1.1943285667419434, 0.5971642833709717]
                }
            );
            break;

    }


    for (var i = 0; i < overlayers.length; i++) {

        if (overlayers[i].visibility == true && overlayers[i].id != 'mydrawlayer') {
            dly.push(
                {
                    baseURL: overlayers[i]._serviceObject._serviceUrl,
                    singleTile: true,
                    layers: [overlayers[i]._layerObject._layerName],
                    opacity: overlayers[i].opacity,
                    type: 'WMS',
                    format: 'image/png',
                    styles: ['']
                }
            );
        }
    }

    // add draw layer
    map.layers.forEach(function (t) {
        if (t.name === "Draw_Layer") {

            var format = new OpenLayers.Format.GeoJSON();
            var geojson = format.write(t.features);

            var nj = JSON.parse(geojson);
            nj.features.forEach(function (feature) {
                feature.properties = {_gx_style: 1};
            });

            dly.push(
            {
                type: 'Vector',
                opacity: '1.0',
                styles:
                    {
                        "1":
                            {
                                "fillColor": "#ffee00",
                                "fillOpacity": 0.2,
                                "hoverFillColor": "white",
                                "hoverFillOpacity": 0.8,
                                "strokeColor": "#ffee00",
                                "strokeOpacity": 1,
                                "strokeWidth": 3,
                                "strokeLinecap": "butt",
                                "strokeDashstyle": "solid",
                                "hoverStrokeColor": "#ffee00",
                                "hoverStrokeOpacity": 1,
                                "hoverStrokeWidth": 0.2,
                                "hoverPointRadius": 1,
                                "hoverPointUnit": "%",
                                "cursor": "inherit",
                                "fontColor": "#000000",
                                "labelAlign": "cm",
                                "labelOutlineColor": "white",
                                "labelOutlineWidth": 3,
                                "graphicOpacity": 1
                            }
                    },
                styleProperty: '_gx_style',
                name: 'simos',
                geoJson : nj
            }
        );
        }
    });

    for (var i = overlayers.length - 1; i >= 0; i--) {

        if (overlayers[i].visibility == true && overlayers[i].id != 'mydrawlayer') {
            var tlly = overlayers[i]._layerObject._layerLegend;

            var tmpurl = window.location.href;
            if (tmpurl.includes('admin')) {
                tlly = tlly.split('url=')[1]
            }
            lly.push(
                {
                    classes: [
                        {
                            icons: [
                                tlly
                            ],
                            name: '',
                            iconBeforeName: false
                        }
                    ],
                    name: overlayers[i]._layerObject._layerTitle
                }
            );
        }
    }

    // for (var i = 0; i < dly.length - 1; i++) {
    //     try {
    //         for (var j = i + 1; i < dly.length; j++) {
    //             if (dly[i].baseURL == dly[j].baseURL) {
    //                 dly[i].layers.push(dly[j].layers[0]);
    //                 dly.splice(j, 1);
    //                 i--;
    //             }
    //         }
    //     } catch (err) {
    //     }
    // }

    var epsg900913 = new OpenLayers.Projection('EPSG:900913');
    var currentProjectio = new OpenLayers.Projection(map_currentProjection);
    var mapcenter = advancedprint_printExtent.geometry.getCentroid().transform(currentProjectio, epsg900913);

    var dta = {
        units: advancedprint_units,
        srs: advancedprint_srs,
        geodetic: true,
        layout: Ext.getCmp('advancedprint_template').getValue(),
        dpi: Ext.getCmp('advancedprint_dpi').getValue(),
        mapTitle: Ext.getCmp('advancedprint_title').getValue(),
        comment: Ext.getCmp('advancedprint_comment').getValue(),
        resourcesUrl: advancedprint_resourcesUrl,
		termsOfUse: "Οροι Χρήσης: ...",
        layers: dly,
        pages: [{
            center: [advancedprint_printExtent.geometry.getCentroid().x, advancedprint_printExtent.geometry.getCentroid().y],
            geodetic: true,
            strictEpsg4326: true,
            scale: Ext.getCmp('advancedprint_scale').getValue(),
            rotation: 0,
            results: {
                /*data: [
                    {id: 1, name: 'text 1', icon: 'logo'},
                    {id: 2, name: 'αβγδεζη', icon: 'logo'},
                    {id: 3, name: 'ικλμνξο', icon: 'logo'},
                    {id: 4, name: 'πρστυφχψω', icon: 'logo'},
                    {id: 5, name: 'ΑΒΓΔΕΖΗΘ', icon: 'logo'},
                    {id: 6, name: 'ΙΚΑΛΜΞΟΠ', icon: 'logo'},
                    {id: 7, name: 'ΡΣΤΥΦΧΨΩ', icon: 'logo'},
                    {id: 8, name: 'άέήίόύώ', icon: 'logo'},
                    {id: 9, name: 'simos', icon: 'logo'},
                    {id: 10, name: 'text 3', icon: 'logo'}
                ],
                columns: ['id', 'name', 'icon']*/
            }
        }],
        legends: lly
    };

    var jsonString = JSON.stringify(dta);

    var p = new fn_get();

    p._async = true;

    p._url = _proxy_url + "?proxy=getPrint&url=" + advancedprint_createURL;

    p._data = jsonString;

    p._timeout = 5000;

    p._success = function (_response, _opts) {

        var url = JSON.parse(_response.responseText).getURL;
        window.open(JSON.parse(_response.responseText).getURL);

    };

    p.get();

}

// Function to create the print extent feature and add it to the map
function advancedprint_createPrintExtent() {

    // Get the current selected scale from the drop-down
    var scale = Ext.getCmp('advancedprint_scale').getValue();

    // Calculate the bounds for the feature based on the selected scale
    var bounds = advancedprint_calculatePrintBounds(scale);

    // Convert the bounds object to a geometry
    var geometry = bounds.toGeometry();

    // Update the geometry of the print extent
    advancedprint_updatePrintExtentGeometry(geometry);

    // Set the centre for the bounds to be the current map centre
    advancedprint_setExtentCentre(map.getCenter());

    // Activate the drag print extent control
    advancedprint_dragPrintExtentCtrl.activate();
}

// Calculate the bounds for the print extent based on the given scale
function advancedprint_calculatePrintBounds(scale) {
    // Get the map units to use
    var units = map.getUnits();

    // Calculate the resolution based on the map units and the scale specified
    var normScale = 1 / scale;
    var resolution = 1 / (normScale * OpenLayers.INCHES_PER_UNIT[units] * 96);

    // Get the printExtent's geometry
    var geom = advancedprint_printExtent.geometry;

    // Get the current centre of the print extent
    var centre = geom.getBounds().getCenterLonLat();

    // Get the size of the currently selected layout's map component
    var width, height;
    for (var i = 0; i < advancedprint_printCapabilities.layouts.length; i++) {
        if (advancedprint_printCapabilities.layouts[i].name == Ext.getCmp('advancedprint_template').getValue()) {
            width = advancedprint_printCapabilities.layouts[i].map.width;
            height = advancedprint_printCapabilities.layouts[i].map.height;
        }
    }

    var size = new OpenLayers.Size(width, height);

    // Calculate the width and the height for the extent in ground units
    var w = size.w * resolution;
    var h = size.h * resolution;

    // Calculate the new bounds and return it
    return bounds = new OpenLayers.Bounds(centre.lon - w, centre.lat - h, centre.lon + w, centre.lat + h);
}

// Update the geometry of the print extent by overwriting it
function advancedprint_updatePrintExtentGeometry(geometry) {
    // Replace the printExtent's geometry with the modified geometry passed in
    geometry.id = advancedprint_printExtent.geometry.id;
    advancedprint_printExtent.geometry = geometry;

    // Redraw the feature on the layer
    advancedprint_printExtentLayer.drawFeature(advancedprint_printExtent);
}

// Set the extent centre to the value passed in
function advancedprint_setExtentCentre(centre) {
    // Get the printExtentFeature geometry
    var geometry = advancedprint_printExtent.geometry;

    // Get the current centre of the extent feature
    var previousCentre = geometry.getBounds().getCenterLonLat();

    // Calculate the deltas between the old and new centre
    var dx = centre.lon - previousCentre.lon;
    var dy = centre.lat - previousCentre.lat;

    // Move the geometry
    geometry.move(dx, dy);

    // Update the feature
    advancedprint_updatePrintExtentGeometry(geometry);
}

function init_advancedprint() {

    var p = new fn_get();

    p._async = true;

    p._url = _proxy_url + "?proxy=proxy&url=" + advancedprint_infourl;

    p._timeout = 5000;

    p._success = function (_response, _opts) {
        try{
            advancedprint_printCapabilities = JSON.parse(_response.responseText);
            advancedprint_printURL = advancedprint_printCapabilities.printURL;
            advancedprint_createURL = advancedprint_printCapabilities.createURL;
    
            for (var i = 0; i < advancedprint_printCapabilities.layouts.length; i++) {
                if (advancedprint_printCapabilities.layouts[i].name !== "PLATE details") {
                    advancedprint_layouts.push([advancedprint_printCapabilities.layouts[i].name, advancedprint_printCapabilities.layouts[i].name]);
                }
            }
            for (var i = 0; i < advancedprint_printCapabilities.scales.length; i++) {
                advancedprint_scales.push([advancedprint_printCapabilities.scales[i].name, advancedprint_printCapabilities.scales[i].value]);
            }
            for (var i = 0; i < advancedprint_printCapabilities.outputFormats.length; i++) {
                advancedprint_outputFormats.push([advancedprint_printCapabilities.outputFormats[i].name, advancedprint_printCapabilities.outputFormats[i].name]);
            }
            for (var i = 0; i < advancedprint_printCapabilities.dpis.length; i++) {
                advancedprint_dpis.push([advancedprint_printCapabilities.dpis[i].name, advancedprint_printCapabilities.dpis[i].value]);
            }
        }catch(err){}
    };

    p.get();

    var advancedprint_button = {
        xtype: 'button',
        id: 'advancedprint_button',
        iconCls: 'maptab_toolbar_general_print',
        tooltip: _maptab_toolbar_general_print,
        text: _maptab_toolbar_general_print,
        handler: function () {
            var w = advancedprint_show_window();
            w.show();
        }
    };

    Ext.getCmp("maptab_toolbar_print_tab").add(advancedprint_button);
}

init_onload_fn.push(init_advancedprint);