// Creates the tab that contains the dropdowns for the parameter selection
function popup_attributes_tab(w) {
    var _layer = mapFindLayerById(w._feature._layerId);
    var feature = fn_fetchGML(w._feature); // DEBUG: Is undefined!
    var layerName = _layer._layerObject._layerName;
    var _Id = Ext.id();
    var d = Array();
    let requestType;

    if (_layer._layerObject._layerId === "da3386bf44588b37a7ff447ae374582f18340009637aa630afaa963a41d3650d") {
      console.debug("REACHED");
      return;
    }

  if (typeof feature != 'undefined') {

    console.debug(layerName);
    console.debug(_layer);
    console.debug(feature);
    console.debug("FEATURE DATA: ", feature.data);
    // fill attributes array with data;
    for (const key in feature.data) {
        // for beach stations unwrap json data type
        if (key === 'station_attributes') {
            let extraAttr = JSON.parse(feature.data['station_attributes']);
            for (const key2 in extraAttr) {
                d.push({
                    "Property": dataSourcesAlias.get(key2) || key2,
                    "Value": extraAttr[key2]
                });
            }
            continue;
        }
        // here we can replace with alias
        d.push({
            "Property": dataSourcesAlias.get(key) || key,
            "Value": feature.data[key]
        });
    }

  }


  requestType = feature.gml.featureType;
  if (requestType != 'cruise_stations' && requestType != 'station'){

    try {
      // TODO: add category data in tree
      requestType = requestType.split('_')[0];
    } catch(err) {
      requestType = 'station';
    }

  }
    var _t = Ext.create('Ext.Panel', {
        title: 'Attributes',
        border: false,
        layout: 'form',
        autoScroll: true,
        height: '100%',
        items: [{
            xtype: 'panel',
            height: '100%',
            html: '<div id="jsGrid"></div>'
        }, {
          html: loadURL(BASE_URL + '/elements/download-button.php?type=' + requestType)
        }],
        listeners: {
            // query: request_attr,
            // Adds the jsGrid inside the tab
            afterrender: function() {
              console.debug(d);
              let stationId = d.filter(a => a.Property == 'id')[0].Value;
              console.debug("STATION ID: ", stationId);

              document.getElementById('btn-download-station-data').setAttribute("x-data", JSON.stringify({ 'ids': stationId }));

                console.debug("ATTRIBUTES: ", d);
              let fData = d.filter(function(el) {
                            return !hiddenRows.includes(el.Property);
                          });
              $("#jsGrid").jsGrid({
                    width: "100%",
                    height: "200px",
                    inserting: false,
                    editing: false,
                    sorting: false,
                    paging: false,
                    data: fData,
                    fields: [{
                        name: "Property",
                        type: "string",
                        width: 100,
                        validate: "required"
                    }, {
                        name: "Value",
                        type: "number",
                        width: 50,
                        align: "left"
                    }]
                });
            }
        }
    });

  ["l"]
    return _t;
}


function request_attr() {
    console.log('requesting attributes...');


}







function filterRow(d) {
  d.filter(function(el) {
    return !hiddenRows.includes(el.Property);
  });
}
