// init_featureInfoWindow_tabs.push(extra_tab_params);

// The following functions add extra custom tabs on specific views
function popup_station_tab(w) {
    var _layer = mapFindLayerById(w._feature._layerId);
    var feature = fn_fetchGML(w._feature);
    var layerName = _layer._layerObject._layerName;


    switch (layerName) {
        case 'cruise_stations':
            var localId = feature.attributes.localId;
            var _Id = Ext.id();
            var _t = Ext.create('Ext.Panel', {
                title: 'Stations',
                border: false,
                layout: 'fit',
                autoScroll: true,
                items: [
                    Ext.create('Ext.grid.Panel', {
                        title: '',
                        id: 'station-panel-1',
                        store: new Ext.data.SimpleStore({
                            autoLoad: 'true',
                            proxy: {
                                type: 'ajax',
                                url: BASE_URL + "/backend/interface_calls/msfd_greece_stations.php",
                                extraParams: {
                                    request: "1",
                                    id: feature.attributes.localId
                                }
                            },
                            fields: [{
                                name: 'stationid',
                                type: 'string'
                            }]
                        }),
                        columns: [{
                            text: 'Station Code',
                            dataIndex: 'stationid'
                        }],
                        height: 200,
                        width: 400,
                    })
                ]
            });

            return _t;
            break;

        case 'pt_asessment_area':
            var code = feature.attributes.code
            var _Id = Ext.id();
            var _t = Ext.create('Ext.Panel', {
                title: 'Σταθμοί',
                border: false,
                layout: 'fit',
                autoScroll: true,
                items: [

                    Ext.create('Ext.grid.Panel', {
                        title: '',
                        id: 'station-panel-2',
                        store: new Ext.data.SimpleStore({
                            autoLoad: 'true',
                            proxy: {
                                type: 'ajax',
                                url: BASE_URL + "/backend/interface_calls/subdivisions_stations.php",
                                extraParams: {
                                    request: "1",
                                    id: feature.attributes.code
                                }
                            },
                            fields: [{
                                name: 'stationid',
                                type: 'string'
                            }]
                        }),
                        columns: [{
                            text: 'Station Code',
                            dataIndex: 'stationid'
                        }],
                        height: 200,
                        width: 400,
                    })
                ]
            });
            return _t;
            break;
        case 'pt_marine_region':
            var code = feature.attributes.code
            var _Id = Ext.id();
            var _t = Ext.create('Ext.Panel', {
                title: 'Σταθμοί',
                border: false,
                layout: 'fit',
                autoScroll: true,
                items: [
                    Ext.create('Ext.grid.Panel', {
                        title: '',
                        id: 'station-panel-2',
                        store: new Ext.data.SimpleStore({
                            autoLoad: 'true',
                            proxy: {
                                type: 'ajax',
                                url: BASE_URL + "/backend/interface_calls/countrywide_stations.php",
                                extraParams: {
                                    request: "1",
                                    id: feature.attributes.code
                                }
                            },
                            fields: [{
                                name: 'stationid',
                                type: 'string'
                            }]
                        }),
                        columns: [{
                            text: 'Station Code',
                            dataIndex: 'stationid'
                        }],
                        height: 200,
                        width: 400,
                    })
                ]
            });
            return _t;
            break;
    }
}

