var PieChartMarker = L.Marker.extend({
    initialize: function(latlng, data, options) {
        L.Marker.prototype.initialize.call(this, latlng, options);
        this.data = data;
    },
    onAdd: function(map) {
        L.Marker.prototype.onAdd.call(this, map);
        this._initPieChart();
    },
    _initPieChart: function() {
        var img = this._icon;
        var canvas = L.DomUtil.create('canvas', '', img);
        var ctx = canvas.getContext('2d');
        var chart = new Chart(ctx, {
            type: 'pie',
            data: {
                labels: this.data.labels,
                datasets: [{
                    data: this.data.values,
                    backgroundColor: this.options.colors || []
                }]
            },
          options: {
            plugins: {
              legend: {
                display: false,
              },
              tooltip: {
                backgroundColor: 'rgba(0,0,0, 0.3)'
              }
            },
            elements: {
              arc: {
                borderWidth: 1
              }
            },
            tooltips: {

        }
          }
 //this.options.chartOptions || {}
        });
        img.style.width = this.options.width + 'px';
        img.style.height = this.options.height + 'px';
    }
});
