<?php
namespace MSFD\Controllers;
use MSFD\Services\PgSql;
use MSFD\Services\GeoserverAPI;


class AuthController {

    public function index() {
        $view = new ViewController();
        $view->render('login', []);
    }

    public function userSignin() {
        $user_id = ''; 
        // Prevent invalid email input 
        $email = $_POST['username']; 
        $password = $_POST['password']; 
        if (!valid_email($email)) { 
            header('HTTP/1.1 422 Unprocessable Entity'); 
            header('Location: login'); 
            exit(422); 
        } 
    
        $api = new GeoserverAPI(); 
        $sql = "select geo_id from webapp.users where email = '{$email}' and password = '{$password}' and origin <> 'GUEST'"; 
        $user_id = PgSql::getCol($sql); 
      
         if (!empty($user_id)) { 
            //  $res = $api->getUser($user_id); 
            $sql_groups = "SELECT group_id FROM webapp.users u 
                JOIN webapp.users__groups ug ON u.geo_id = ug.user_id 
                WHERE geo_id = '{$user_id}'"; 
            $user_groups = Pgsql::getColValues($sql_groups); 
            $sql_name = "SELECT fname FROM webapp.users u 
                WHERE geo_id = '{$user_id}'"; 
            $user_name = PgSql::getCol($sql_name); 
      
            $_SESSION['user_id'] = $user_id; 
            $_SESSION['user_groups'] = $user_groups; 
            $_SESSION['user_name'] = $user_name; 

            header('Location: /'); 
            exit(0); 
         } else { 
            echo 'No such user'; 
            header('HTTP/1.1 403 Forbidden'); 
            header('Refresh: 2; URL = index.php'); 
            exit(403); 
         } 
    }


    public function guestSignin() {
        // Prevent invalid email input
        $email = $_POST['username'];
        if (!valid_email($email)) {
            header('HTTP/1.1 422 Unprocessable Entity');
            header('Location: login');
            exit(422);
        }

        $sql = "select geo_id from webapp.users where email = '{$email}' and origin <> 'GUEST'";
        $user_id = PgSql::getCol($sql);

        // if the query result is not empty then the user is already registered
        if (!empty($user_id)) {
          echo "user {$email} is registered. Login as a registered user!";
          header('HTTP/1.1 400 Bad Request');
          exit(400);
        }

        if (!self::isEmail($email)) {
            header('HTTP/1.1 422 Unprocessable Entity');
            header('Location: login');
            exit(422);
        }
    
        // Handle guest login
        if (isset($_POST['username'])) {
            $_SESSION['user_groups'] = [1];
            $_SESSION['user_name'] = "Guest";
            $_SESSION['user_id'] = self::insertGuestUser($email);

            $s = self::insertGuestGroup($_SESSION['user_id']);

            header('HTTP/1.1 302 Found');
            header('Location: /');
            exit(0);
        } else { // handle user login
          header('HTTP/1.1 500 Server error');
          exit(500);
        }
    }


    public function logout() {
        session_start(); 
        session_destroy();
        unset($_SESSION);
        $_SESSION = array(); 
        header("Location: login");
        exit();
    }

    private function isEmail($email) {
        return filter_var($email, FILTER_VALIDATE_EMAIL);
    }


    private function insertGuestUser($email) {
      $sql = "INSERT INTO webapp.users (email, origin, password)
              VALUES ('{$email}', 'GUEST', '') 
              ON CONFLICT (email) DO UPDATE
              SET last_login = now()";

        $res = PgSql::insert($sql, 'geo_id');
        return json_decode($res)->geo_id;
    }

    private function insertGuestGroup($id) {
        $sql = "INSERT INTO webapp.users__groups (user_id, group_id)
                VALUES ('{$id}', 1) ON CONFLICT DO NOTHING";

        PgSql::insert($sql, 'NULL');
    }
}


function guidv4($data = null) {
    // Generate 16 bytes (128 bits) of random data or use the data passed into the function.
    $data = $data ?? random_bytes(16);
    assert(strlen($data) == 16);
    // Set version to 0100
    $data[6] = chr(ord($data[6]) & 0x0f | 0x40);
    // Set bits 6-7 to 10
    $data[8] = chr(ord($data[8]) & 0x3f | 0x80);

    // Output the 36 character UUID.
    return vsprintf('%s%s-%s-%s-%s-%s%s%s', str_split(bin2hex($data), 4));
}


function valid_email($str) {
    return (!preg_match("/^([a-z0-9\+_\-]+)(\.[a-z0-9\+_\-]+)*@([a-z0-9\-]+\.)+[a-z]{2,6}$/ix", $str)) ? FALSE : TRUE;
}
