<?php
namespace MSFD\Data;
use MSFD\Services\PgSql;
use MSFD\Services\RepoAPI;
/**
* this class generates request objects to be used in the requests table on the frontend
*
* @param {array} attributes
 */
class DataRequest {
    public function __construct($attr, $user_id) {
        $this->body_id = $attr['bodyId'];
        $this->crit_id = $attr['critId'];
        $this->date_from = $attr['dateFrom'];
        $this->date_to = $attr['dateTo'];
        $this->user_id = $user_id;
        $attr['userid'] = $user_id;
        $this->entity_id = $attr['entityId'];
        $this->entity_group = $attr['entityGroup'];
        $this->params = json_encode([$attr]);
    }


    // queries entry from requests table
    /**
    * @param uuid
    * @return entry
     */
    public function get_entry() {

    }

    // fetches the accessible and ready file from the repo
    /**
    * @param uuid
    * @return file
     */
    public function get_requested_file($request_uuid) {

        /* $url = Constants::getAPIBaseUrl('REPO').'/raw_data?' . $request_uuid; */
        /* file_get_contents($this->endpoint); */
        $api = new RepoApi();
        file_get_contents($api->get_file($request_uuid));
    }


    // inserts the initial request entry without connection to query or file
    function insert_to_db() {
        //TODO: change body id and crit id with verbose codes for the filename

        $from = $this->format_date($this->date_from);
        $to = $this->format_date($this->date_to);
        $name_prefix = "{$this->body_id}_{$this->crit_id}_{$from}_{$to}";
        $filename = $name_prefix . "-" . substr(microtime(true) * 10000, 8) . '.csv';
        $sql = "INSERT INTO webapp.requests(user_uuid, attributes)
            VALUES ('{$this->user_id}', '{$this->params}'::jsonb)";
        $res = PgSql::insert($sql, 'uuid', 'request_timestamp');
        // store info of the inserted request
        $this->entry = json_decode($res);
        return $res;
    }


    function clear_user_requests() {
        echo $this->user_id;
        /* $db = new PgSql(); */
        $sql = "DELETE FROM webapp.requests WHERE user_uuid = '{$this->user_id}'";
        return PgSql::exec($sql);
    }

    // calls repo api to begin file generation
    private function format_date($input) {
        $date = date('ymd', strtotime($input));
        return $date;
    }



}
