<?php

/**
 * Init AltoRouter.
 */
$router = new AltoRouter();

/**
 * Base Routes.
 */
$router->map('GET', '/', 'MSFD\Controllers\HomeController@index', 'home');
$router->map('GET', '/login', 'MSFD\Controllers\AuthController@index', 'login');
$router->map('POST', '/userlogin', 'MSFD\Controllers\AuthController@userSignin', 'usersignin');
$router->map('POST', '/guestlogin', 'MSFD\Controllers\AuthController@guestSignin', 'guestsignin');

$router->map('GET', '/logout', 'MSFD\Controllers\AuthController@logout', 'logout');
$router->map('GET', '/fetch_request_list', 'MSFD\Controllers\DataController@fetch', 'fetch');

$router->map('GET', '/geoserver/wms', 'MSFD\Controllers\GeoserverController@wms', 'wms');
$router->map('GET', '/geoserver/shapefile/[:layer]/[:srs]', 'MSFD\Controllers\GeoserverController@downloadShapefile', 'shapefile');

$router->map('GET', '/data/external/[:layer]/[:platform]', 'MSFD\Controllers\DataController@fetchExternalData', 'fetch_external');
$router->map('GET', '/interface/partial/[:partial]', 'MSFD\Controllers\InterfaceController@getPartial', 'fetch_partial');
// $router->map('GET', '/interface/page/[a:page]', 'MSFD\Controllers\InterfaceController@getPage', 'fetch_page');

$router->map('GET', '/geonetwork/getrecords', 'MSFD\Controllers\GeonetworkController@getRecords', 'fetch_meta');

// Admin panel routes
$router->map('GET', '/cp/fetch_user_list', 'MSFD\Controllers\AdminController@fetchUsers', 'users');


