<div class="is-flex" x-data="{choice: 'userslist'}">
<aside class="menu">
  <p class="menu-label">
    General
  </p>
  <ul class="menu-list">
    <li><a :class="{'is-active': choice == 'userslist'}" @click="choice = 'userslist'">Users List</a></li>
    <li><a :class="{'is-active': choice == 'users'}" @click="choice = 'users'">Users</a></li>
    <li><a :class="{'is-active': choice == 'layers'}" @click="choice = 'layers'">Layers</a></li>
  </ul>
</aside>
<main class="is-flex-grow p-6">
  <section class="tile is-ancestor" x-show="choice == 'userslist'">
    <div id="table-users">
    </div>
  </section>
  <section class="tile is-ancestor" x-show="choice == 'users'">
    <div class="tile is-vertical">
    <div class="field">
      <label class="label">First Name</label>
      <div class="control">
        <input class="input" type="text" placeholder="e.g. John">
      </div>
    </div>
    <div class="field">
    <label class="label">Last Name</label>
      <div class="control">
        <input class="input" type="text" placeholder="e.g. Doe">
      </div>
    </div>
    <div class="field">
      <label class="label">Organization</label>
      <div class="control has-icons-left has-icons-right">
        <input class="input is-success" type="text" placeholder="e.g. HCMR" >
        <span class="icon is-small is-left">
         <i class="fa-solid fa-building-columns"></i>
       </span>
      </div>
    </div>
    <div class="field is-hidden">
      <label class="label">Organization</label>
      <div class="control has-icons-left has-icons-right">
        <input class="input is-success" type="text" placeholder="Text input">
        <span class="icon is-small is-left">
          <i class="fas fa-user"></i>
        </span>
        <span class="icon is-small is-right">
          <i class="fas fa-check"></i>
        </span>
      </div>
      <p class="help is-success">This username is available</p>
    </div>
    <div class="field">
      <label class="label">Email</label>
      <div class="control has-icons-left has-icons-right">
        <input class="input is-danger" type="email" placeholder="e.g. johndoe@gmail.com">
        <span class="icon is-small is-left">
          <i class="fas fa-envelope"></i>
        </span>
        <span class="icon is-small is-right">
          <i class="fas fa-exclamation-triangle"></i>
        </span>
      </div>
      <p class="help is-danger">This email is invalid</p>
    </div>

    <div class="field">
      <label class="label">Role</label>
      <div class="control">
        <div class="select">
          <select>
            <option>ADMIN</option>
            <option>HCMR</option>
            <option>ΙΝΑΛΕ</option>
            <option>GOV</option>
          </select>
        </div>
      </div>
    </div>

    <div class="field is-hidden">
      <label class="label">Message</label>
      <div class="control">
        <textarea class="textarea" placeholder="Textarea"></textarea>
      </div>
    </div>

    <div class="field is-hidden">
      <div class="control">
        <label class="checkbox">
          <input type="checkbox">
          I agree to the <a href="#">terms and conditions</a>
        </label>
      </div>
    </div>
    <div class="field is-hidden">
      <div class="control">
        <label class="radio">
          <input type="radio" name="question">
          Yes
        </label>
        <label class="radio">
          <input type="radio" name="question">
          No
        </label>
      </div>
    </div>

    <div class="field is-grouped">
      <div class="control">
        <button class="button is-link">Submit</button>
      </div>
      <div class="control">
        <button class="button is-link is-light">Cancel</button>
      </div>
    </div>
    </div>
    <!-- tile is-parent end -->
<!-- user list tile -->
    <div class="tile">
    </div>

  </section>
</main>
</div>

<script>
let usersGrid = $("#table-users").jsGrid({
                width: "100%",
                height: '100%',
                inserting: false,
                editing: false,
                sorting: false,
                paging: false,
                data: [
                    {
                        username: "o.moresis@hcmr.gr",
                        name: "Orestis",
                        surname: "Moresis",
                        enabled: true,
                        origin: "HCMR",
                        role: "ADMIN"
                    },
                    {
                        username: "ginimaria3@gmail.com",
                        name: "Maria",
                        surname: "Gkini",
                        enabled: true,
                        origin: "GOV",
                        role: 'ADMIN'
                    },
                    {
                        username: "ch955ch955@gmail.com",
                        name: "Christina",
                        surname: "Andrikopoulou",
                        enabled: true,
                        origin: "GOV",
                        role: 'ADMIN'
                    },
                    {
                        username: "s.charisi@prv.ypeka.gr",
                        name: "Stella",
                        surname: "Charisi",
                        enabled: true,
                        origin: "GOV",
                        role: 'ADMIN'
                    },
                    {
                        username: "g_theof@yahoo.com",
                        name: "Georgios",
                        surname: "Theofilopoulos",
                        enabled: true,
                        origin: "GOV",
                        role: 'ADMIN'
                    },{
                        username: "e.alexaki@prv.ypeka.gr",
                        name: "Elena",
                        surname: "Alexaki",
                        enabled: true,
                        origin: "YPEN",
                        role: 'ADMIN'
                    },{
                        username: "vaslak@hcmr.gr",
                        name: "Vasilis",
                        surname: "Lakes",
                        enabled: true,
                        origin: "HCMR",
                        role: 'ADMIN'
                    }
                ],
                onItemDeleting: function(row) {
                    const id = row.item.evid;
                    const searchGridData = $("#searchGrid").jsGrid("option", "data");
                    searchGridData.some((k,v) => {
                        if (k.evid == id) {
                            const searchGridRow = $("#searchGrid").jsGrid("rowByItem", k);
                            let rowBtn = searchGridRow.children(".jsgrid-control-field")[0].childNodes[0].childNodes[0];
                            rowBtn.classList.remove("jsgrid-update-button");
                            rowBtn.classList.add("jsgrid-insert-button");
                        }
                    });
                },
                fields: [{
                    name: "username",
                    type: "text",
                    width: 150,
                    align: 'center'
                },{
                    name: "name",
                    type: "text",
                    width: 50,
                    align: 'center'
                },{
                    name: "surname",
                    type: "text",
                    width: 50,
                    align: 'center'
                },{
                    name: "enabled",
                    type: "boolean",
                    width: 50,
                    align: 'center'
                },{
                    name: "origin",
                    type: "text",
                    width: 50,
                    align: 'center'
                },{
                    name: "role",
                    type: "text",
                    width: 50,
                    align: 'center'
                }]
            });
</script>
