<section id="map-view" :class="isActiveTab(1) ? '' : 'is-hidden'" x-init="init_leaflet_map()">
</section>
<script>
function init_leaflet_map()
{
  mapL = L.map('map-view', {
        center: [37.541627365379, 25.175245212016],
        zoom: 7
      });
  let baseLayer = L.tileLayer('https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', {
    attribution: '&copy; <a href="https://www.openstreetmap.org/copyright">OpenStreetMap</a> contributors',
    crs: L.CRS.EPSG4326
  }).addTo(mapL);
	_map_config_object = new _config_init_map();
  // hide spinner after base map loads
  baseLayer.on('load', function(event) { 
    // console.debug(Alpine.store('isLoading'));
    Alpine.store('loading', false);
    // document.getElementById('spinner').classList.add('is-hidden');
  })
  // hide attribution
  document.getElementsByClassName( 'leaflet-control-attribution' )[0].style.display = 'none';
  mapL.pm.addControls({
    position: 'topleft',
    drawCircle: false,
  });

  L.control.scale().addTo(mapL);
}
</script>
<style>
   #map-view {
    height: 100%;
}
</style>
