<div id="grid-requests" class="flex-grow" x-ref="requests"></div>
<p class="ml-6">*Your request contains restricted data. Please contact the Institute's primary investigator at <a href="mailto:sissy@hcmr.gr">helpdesk@hcmr.gr</a> using the UUID of the request you wish to receive</p>
<button class="button m-5" @click="downloadData()">Download All</button>
<button class="button m-5" @click="clearRequests()">Clear All</button>
<script>
function makeRequestsGrid() {
     window.requestsGrid = new gridjs.Grid({
      columns: ['UUID', 'Criterias',
        {
          name: 'Requested At',
        },
        {
          name: 'Status',
        },
        {
        name: 'Actions',
        formatter: (cell, row) => {
          if (cell == 'f') {
            return "";
          }
          return gridjs.h('button', {
            className: 'py-2 mb-4 px-4 border rounded-md text-white bg-blue-600',
            onClick: () => downloadOneFile(row.cells[0].data)
          }, 'Download');
        }
      }],
      search: false,
      server: {
          url: BASE_URL + '/actions/requests/',
          then: data => data.map(reqs => [reqs.uuid, reqs.criterias, reqs.requested_at, reqs.status, reqs.downloadable])
      }
    }).render(document.getElementById('grid-requests'));

    setInterval(function() {
      requestsGrid.forceRender();
    }, 20000);
}
</script>
