<div id="wrapper" x-data="{
  activeTab: 1,
  isLoading: $store.loading,
  setActiveTab(value) {
      this.activeTab = value;
  },
  isActiveTab(tab) {
      return tab == this.activeTab;
  },
  downloadData() {
      downloadRequested();
  }
}" x-init="$store.loading = true" class="is-flex is-flex-direction-column">
<nav class="tabs is-centered is-boxed">
  <ul>
    <li :class="isActiveTab(1) ? 'is-active' : ''">
      <a @click="setActiveTab(1)">
        <span class="icon is-small"><i class="fas fa-earth-europe" aria-hidden="true"></i></span>
        <span>Map</span>
      </a>
    </li>
    <li :class="isActiveTab(2) ? 'is-active' : ''">
      <a @click="setActiveTab(2); metadata_search()">
        <span class="icon is-small"><i class="fas fa-server" aria-hidden="true"></i></span>
        <span>Metadata</span>
      </a>
    </li>
    <li :class="isActiveTab(3) ? 'is-active' : ''">
      <a @click="setActiveTab(3)">
        <span class="icon is-small"><i class="fas fa-book" aria-hidden="true"></i></span>
        <span>User Manual</span>
      </a>
    </li>
    <li :class="isActiveTab(4) ? 'is-active' : ''">
      <a @click="setActiveTab(4)">
        <span class="icon is-small"><i class="fas fa-chart-column" aria-hidden="true"></i></span>
        <span>Statistics</span>
      </a>
    </li>
    <li x-show="isAdmin" :class="isActiveTab(5) ? 'is-active' : ''">
      <a @click="setActiveTab(5)">
        <span class="icon is-small"><i class="fas fa-screwdriver-wrench" aria-hidden="true"></i></span>
        <span>Admin Panel</span>
      </a>
    </li>
  </ul>

  <div id="login-status" class="mr-10 is-inline-flex is-align-items-center"><span x-text="'Welcome ' + userName"></span> <a id="btn-logout" href="logout">Log Out</a></div>
</nav>
<div id="main-view" class="columns is-flex-grow-1 px-4">
    <aside class="column is-one-third pb-10">
        <?php include('sidebar-panel.php');?>
        <?php include('sidebar-docs.php');?>
    </aside>
    <main class="column">
        <?php include('main-map.php'); ?>
        <?php include('main-metadata.php'); ?>
        <?php include('main-about.php'); ?>
        <?php include('main-statistics.php'); ?>
        <?php include('main-admin.php'); ?>
    </main>
</div>
    <?php include('spinner.php'); ?>
</div>
<style>
    #login-status {
        position: absolute;
        right: 25px;
    }

    #wrapper {
        height: 100%;
        width: 100%;
    }

    #main-view {
        max-height: inherit;
        overflow: hidden;
    }
</style>
