<?php
use MSFD\Services\PgSql;
use MSFD\Config;

/**
 * Start Session.
 */
if (!isset($_SESSION)) {
    session_start();
}

header("Access-Control-Allow-Origin: *");
/**
 * Load Environment Variables.
 */
require_once __DIR__.'/Config.php';

/**
* Init DB connection
*/
PgSql::initialize(Config::getDatabaseCreds());
/**
 * Load Routes.
 */
require_once __DIR__.'/Routing/routes.php';
require_once __DIR__.'/Routing/controls.php';
require_once __DIR__.'/Routing/RouteDispatcher.php';

/**
 * Init Route Dispatcher.
 */
new MSFD\Routing\RouteDispatcher($router);

/**
* Terminate DB connection
*/
PgSql::close();
